# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AvailabilityType',
    'CloudInitDataSource',
    'DiagnosticLevel',
    'DiskFileFormat',
    'ExtendedLocationTypes',
    'HyperVGeneration',
    'IPPoolTypeEnum',
    'IpAllocationMethodEnum',
    'ManagedServiceIdentityType',
    'NetworkTypeEnum',
    'OperatingSystemTypes',
    'OsTypeEnum',
    'PrivateIPAllocationMethodEnum',
    'ResourceIdentityType',
    'SoftwareAssuranceIntent',
    'SoftwareAssuranceStatus',
    'State',
    'UpdateRunPropertiesState',
    'UpdateSummariesPropertiesState',
    'WindowsServerSubscription',
]


class AvailabilityType(str, Enum):
    """
    Indicates the way the update content can be downloaded.
    """
    LOCAL = "Local"
    ONLINE = "Online"
    NOTIFY = "Notify"


class CloudInitDataSource(str, Enum):
    """
    Datasource for the gallery image when provisioning with cloud-init [Azure, NoCloud]
    """
    NO_CLOUD = "NoCloud"
    AZURE = "Azure"


class DiagnosticLevel(str, Enum):
    """
    Desired level of diagnostic data emitted by the cluster.
    """
    OFF = "Off"
    BASIC = "Basic"
    ENHANCED = "Enhanced"


class DiskFileFormat(str, Enum):
    """
    The format of the actual VHD file [vhd, vhdx]
    """
    VHDX = "vhdx"
    VHD = "vhd"


class ExtendedLocationTypes(str, Enum):
    """
    The type of the extended location.
    """
    CUSTOM_LOCATION = "CustomLocation"


class HyperVGeneration(str, Enum):
    """
    The hypervisor generation of the Virtual Machine [V1, V2]
    """
    V1 = "V1"
    V2 = "V2"


class IPPoolTypeEnum(str, Enum):
    """
    ip pool type
    """
    VM = "vm"
    VIPPOOL = "vippool"


class IpAllocationMethodEnum(str, Enum):
    """
    IPAllocationMethod - The IP address allocation method. Possible values include: 'Static', 'Dynamic'
    """
    DYNAMIC = "Dynamic"
    STATIC = "Static"


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned, UserAssigned"


class NetworkTypeEnum(str, Enum):
    """
    Type of the network
    """
    NAT = "NAT"
    TRANSPARENT = "Transparent"
    L2_BRIDGE = "L2Bridge"
    L2_TUNNEL = "L2Tunnel"
    ICS = "ICS"
    PRIVATE = "Private"
    OVERLAY = "Overlay"
    INTERNAL = "Internal"
    MIRRORED = "Mirrored"


class OperatingSystemTypes(str, Enum):
    """
    operating system type that the gallery image uses. Expected to be linux or windows
    """
    WINDOWS = "Windows"
    LINUX = "Linux"


class OsTypeEnum(str, Enum):
    """
    OsType - string specifying whether the OS is Linux or Windows
    """
    LINUX = "Linux"
    WINDOWS = "Windows"


class PrivateIPAllocationMethodEnum(str, Enum):
    """
    PrivateIPAllocationMethod - The private IP address allocation method. Possible values include: 'Static', 'Dynamic'
    """
    DYNAMIC = "Dynamic"
    STATIC = "Static"


class ResourceIdentityType(str, Enum):
    """
    The identity type.
    """
    SYSTEM_ASSIGNED = "SystemAssigned"


class SoftwareAssuranceIntent(str, Enum):
    """
    Customer Intent for Software Assurance Benefit.
    """
    ENABLE = "Enable"
    DISABLE = "Disable"


class SoftwareAssuranceStatus(str, Enum):
    """
    Status of the Software Assurance for the cluster.
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class State(str, Enum):
    """
    State of the update as it relates to this stamp.
    """
    HAS_PREREQUISITE = "HasPrerequisite"
    OBSOLETE = "Obsolete"
    READY = "Ready"
    NOT_APPLICABLE_BECAUSE_ANOTHER_UPDATE_IS_IN_PROGRESS = "NotApplicableBecauseAnotherUpdateIsInProgress"
    PREPARING = "Preparing"
    INSTALLING = "Installing"
    INSTALLED = "Installed"
    PREPARATION_FAILED = "PreparationFailed"
    INSTALLATION_FAILED = "InstallationFailed"
    INVALID = "Invalid"
    RECALLED = "Recalled"
    DOWNLOADING = "Downloading"
    DOWNLOAD_FAILED = "DownloadFailed"
    HEALTH_CHECKING = "HealthChecking"
    HEALTH_CHECK_FAILED = "HealthCheckFailed"
    READY_TO_INSTALL = "ReadyToInstall"
    SCAN_IN_PROGRESS = "ScanInProgress"
    SCAN_FAILED = "ScanFailed"


class UpdateRunPropertiesState(str, Enum):
    """
    State of the update run.
    """
    UNKNOWN = "Unknown"
    SUCCEEDED = "Succeeded"
    IN_PROGRESS = "InProgress"
    FAILED = "Failed"


class UpdateSummariesPropertiesState(str, Enum):
    """
    Overall update state of the stamp.
    """
    UNKNOWN = "Unknown"
    APPLIED_SUCCESSFULLY = "AppliedSuccessfully"
    UPDATE_AVAILABLE = "UpdateAvailable"
    UPDATE_IN_PROGRESS = "UpdateInProgress"
    UPDATE_FAILED = "UpdateFailed"
    NEEDS_ATTENTION = "NeedsAttention"
    PREPARATION_IN_PROGRESS = "PreparationInProgress"
    PREPARATION_FAILED = "PreparationFailed"


class WindowsServerSubscription(str, Enum):
    """
    Desired state of Windows Server Subscription.
    """
    DISABLED = "Disabled"
    ENABLED = "Enabled"
