# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from ._enums import *

__all__ = [
    'AzureDataExplorerConnectionPropertiesArgs',
]

@pulumi.input_type
class AzureDataExplorerConnectionPropertiesArgs:
    def __init__(__self__, *,
                 adx_database_name: pulumi.Input[str],
                 adx_endpoint_uri: pulumi.Input[str],
                 adx_resource_id: pulumi.Input[str],
                 connection_type: pulumi.Input[str],
                 event_hub_endpoint_uri: pulumi.Input[str],
                 event_hub_entity_path: pulumi.Input[str],
                 event_hub_namespace_resource_id: pulumi.Input[str],
                 adx_table_name: Optional[pulumi.Input[str]] = None,
                 event_hub_consumer_group: Optional[pulumi.Input[str]] = None):
        """
        Properties of a time series database connection to Azure Data Explorer with data being sent via an EventHub.
        :param pulumi.Input[str] adx_database_name: The name of the Azure Data Explorer database.
        :param pulumi.Input[str] adx_endpoint_uri: The URI of the Azure Data Explorer endpoint.
        :param pulumi.Input[str] adx_resource_id: The resource ID of the Azure Data Explorer cluster.
        :param pulumi.Input[str] connection_type: The type of time series connection resource.
               Expected value is 'AzureDataExplorer'.
        :param pulumi.Input[str] event_hub_endpoint_uri: The URL of the EventHub namespace for identity-based authentication. It must include the protocol sb://
        :param pulumi.Input[str] event_hub_entity_path: The EventHub name in the EventHub namespace for identity-based authentication.
        :param pulumi.Input[str] event_hub_namespace_resource_id: The resource ID of the EventHub namespace.
        :param pulumi.Input[str] adx_table_name: The name of the Azure Data Explorer table. Defaults to AdtPropertyEvents.
        :param pulumi.Input[str] event_hub_consumer_group: The EventHub consumer group to use when ADX reads from EventHub. Defaults to $Default.
        """
        pulumi.set(__self__, "adx_database_name", adx_database_name)
        pulumi.set(__self__, "adx_endpoint_uri", adx_endpoint_uri)
        pulumi.set(__self__, "adx_resource_id", adx_resource_id)
        pulumi.set(__self__, "connection_type", 'AzureDataExplorer')
        pulumi.set(__self__, "event_hub_endpoint_uri", event_hub_endpoint_uri)
        pulumi.set(__self__, "event_hub_entity_path", event_hub_entity_path)
        pulumi.set(__self__, "event_hub_namespace_resource_id", event_hub_namespace_resource_id)
        if adx_table_name is None:
            adx_table_name = 'AdtPropertyEvents'
        if adx_table_name is not None:
            pulumi.set(__self__, "adx_table_name", adx_table_name)
        if event_hub_consumer_group is None:
            event_hub_consumer_group = '$Default'
        if event_hub_consumer_group is not None:
            pulumi.set(__self__, "event_hub_consumer_group", event_hub_consumer_group)

    @property
    @pulumi.getter(name="adxDatabaseName")
    def adx_database_name(self) -> pulumi.Input[str]:
        """
        The name of the Azure Data Explorer database.
        """
        return pulumi.get(self, "adx_database_name")

    @adx_database_name.setter
    def adx_database_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "adx_database_name", value)

    @property
    @pulumi.getter(name="adxEndpointUri")
    def adx_endpoint_uri(self) -> pulumi.Input[str]:
        """
        The URI of the Azure Data Explorer endpoint.
        """
        return pulumi.get(self, "adx_endpoint_uri")

    @adx_endpoint_uri.setter
    def adx_endpoint_uri(self, value: pulumi.Input[str]):
        pulumi.set(self, "adx_endpoint_uri", value)

    @property
    @pulumi.getter(name="adxResourceId")
    def adx_resource_id(self) -> pulumi.Input[str]:
        """
        The resource ID of the Azure Data Explorer cluster.
        """
        return pulumi.get(self, "adx_resource_id")

    @adx_resource_id.setter
    def adx_resource_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "adx_resource_id", value)

    @property
    @pulumi.getter(name="connectionType")
    def connection_type(self) -> pulumi.Input[str]:
        """
        The type of time series connection resource.
        Expected value is 'AzureDataExplorer'.
        """
        return pulumi.get(self, "connection_type")

    @connection_type.setter
    def connection_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "connection_type", value)

    @property
    @pulumi.getter(name="eventHubEndpointUri")
    def event_hub_endpoint_uri(self) -> pulumi.Input[str]:
        """
        The URL of the EventHub namespace for identity-based authentication. It must include the protocol sb://
        """
        return pulumi.get(self, "event_hub_endpoint_uri")

    @event_hub_endpoint_uri.setter
    def event_hub_endpoint_uri(self, value: pulumi.Input[str]):
        pulumi.set(self, "event_hub_endpoint_uri", value)

    @property
    @pulumi.getter(name="eventHubEntityPath")
    def event_hub_entity_path(self) -> pulumi.Input[str]:
        """
        The EventHub name in the EventHub namespace for identity-based authentication.
        """
        return pulumi.get(self, "event_hub_entity_path")

    @event_hub_entity_path.setter
    def event_hub_entity_path(self, value: pulumi.Input[str]):
        pulumi.set(self, "event_hub_entity_path", value)

    @property
    @pulumi.getter(name="eventHubNamespaceResourceId")
    def event_hub_namespace_resource_id(self) -> pulumi.Input[str]:
        """
        The resource ID of the EventHub namespace.
        """
        return pulumi.get(self, "event_hub_namespace_resource_id")

    @event_hub_namespace_resource_id.setter
    def event_hub_namespace_resource_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "event_hub_namespace_resource_id", value)

    @property
    @pulumi.getter(name="adxTableName")
    def adx_table_name(self) -> Optional[pulumi.Input[str]]:
        """
        The name of the Azure Data Explorer table. Defaults to AdtPropertyEvents.
        """
        return pulumi.get(self, "adx_table_name")

    @adx_table_name.setter
    def adx_table_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "adx_table_name", value)

    @property
    @pulumi.getter(name="eventHubConsumerGroup")
    def event_hub_consumer_group(self) -> Optional[pulumi.Input[str]]:
        """
        The EventHub consumer group to use when ADX reads from EventHub. Defaults to $Default.
        """
        return pulumi.get(self, "event_hub_consumer_group")

    @event_hub_consumer_group.setter
    def event_hub_consumer_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "event_hub_consumer_group", value)


