# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from ._enums import *

__all__ = [
    'ProtocolCustomSettingsFormatResponse',
    'RoutingPolicyResponse',
    'SubResourceResponse',
    'VpnServerConfigurationPolicyGroupMemberResponse',
]

@pulumi.output_type
class ProtocolCustomSettingsFormatResponse(dict):
    """
    DDoS custom policy properties.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "sourceRateOverride":
            suggest = "source_rate_override"
        elif key == "triggerRateOverride":
            suggest = "trigger_rate_override"
        elif key == "triggerSensitivityOverride":
            suggest = "trigger_sensitivity_override"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProtocolCustomSettingsFormatResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProtocolCustomSettingsFormatResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProtocolCustomSettingsFormatResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 protocol: Optional[str] = None,
                 source_rate_override: Optional[str] = None,
                 trigger_rate_override: Optional[str] = None,
                 trigger_sensitivity_override: Optional[str] = None):
        """
        DDoS custom policy properties.
        :param str protocol: The protocol for which the DDoS protection policy is being customized.
        :param str source_rate_override: The customized DDoS protection source rate.
        :param str trigger_rate_override: The customized DDoS protection trigger rate.
        :param str trigger_sensitivity_override: The customized DDoS protection trigger rate sensitivity degrees. High: Trigger rate set with most sensitivity w.r.t. normal traffic. Default: Trigger rate set with moderate sensitivity w.r.t. normal traffic. Low: Trigger rate set with less sensitivity w.r.t. normal traffic. Relaxed: Trigger rate set with least sensitivity w.r.t. normal traffic.
        """
        if protocol is not None:
            pulumi.set(__self__, "protocol", protocol)
        if source_rate_override is not None:
            pulumi.set(__self__, "source_rate_override", source_rate_override)
        if trigger_rate_override is not None:
            pulumi.set(__self__, "trigger_rate_override", trigger_rate_override)
        if trigger_sensitivity_override is not None:
            pulumi.set(__self__, "trigger_sensitivity_override", trigger_sensitivity_override)

    @property
    @pulumi.getter
    def protocol(self) -> Optional[str]:
        """
        The protocol for which the DDoS protection policy is being customized.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="sourceRateOverride")
    def source_rate_override(self) -> Optional[str]:
        """
        The customized DDoS protection source rate.
        """
        return pulumi.get(self, "source_rate_override")

    @property
    @pulumi.getter(name="triggerRateOverride")
    def trigger_rate_override(self) -> Optional[str]:
        """
        The customized DDoS protection trigger rate.
        """
        return pulumi.get(self, "trigger_rate_override")

    @property
    @pulumi.getter(name="triggerSensitivityOverride")
    def trigger_sensitivity_override(self) -> Optional[str]:
        """
        The customized DDoS protection trigger rate sensitivity degrees. High: Trigger rate set with most sensitivity w.r.t. normal traffic. Default: Trigger rate set with moderate sensitivity w.r.t. normal traffic. Low: Trigger rate set with less sensitivity w.r.t. normal traffic. Relaxed: Trigger rate set with least sensitivity w.r.t. normal traffic.
        """
        return pulumi.get(self, "trigger_sensitivity_override")


@pulumi.output_type
class RoutingPolicyResponse(dict):
    """
    The routing policy object used in a RoutingIntent resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "nextHop":
            suggest = "next_hop"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RoutingPolicyResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RoutingPolicyResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RoutingPolicyResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 destinations: Sequence[str],
                 name: str,
                 next_hop: str):
        """
        The routing policy object used in a RoutingIntent resource.
        :param Sequence[str] destinations: List of all destinations which this routing policy is applicable to (for example: Internet, PrivateTraffic).
        :param str name: The unique name for the routing policy.
        :param str next_hop: The next hop resource id on which this routing policy is applicable to.
        """
        pulumi.set(__self__, "destinations", destinations)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "next_hop", next_hop)

    @property
    @pulumi.getter
    def destinations(self) -> Sequence[str]:
        """
        List of all destinations which this routing policy is applicable to (for example: Internet, PrivateTraffic).
        """
        return pulumi.get(self, "destinations")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The unique name for the routing policy.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nextHop")
    def next_hop(self) -> str:
        """
        The next hop resource id on which this routing policy is applicable to.
        """
        return pulumi.get(self, "next_hop")


@pulumi.output_type
class SubResourceResponse(dict):
    """
    Reference to another subresource.
    """
    def __init__(__self__, *,
                 id: Optional[str] = None):
        """
        Reference to another subresource.
        :param str id: Resource ID.
        """
        if id is not None:
            pulumi.set(__self__, "id", id)

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        Resource ID.
        """
        return pulumi.get(self, "id")


@pulumi.output_type
class VpnServerConfigurationPolicyGroupMemberResponse(dict):
    """
    VpnServerConfiguration PolicyGroup member
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "attributeType":
            suggest = "attribute_type"
        elif key == "attributeValue":
            suggest = "attribute_value"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in VpnServerConfigurationPolicyGroupMemberResponse. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        VpnServerConfigurationPolicyGroupMemberResponse.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        VpnServerConfigurationPolicyGroupMemberResponse.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 attribute_type: Optional[str] = None,
                 attribute_value: Optional[str] = None,
                 name: Optional[str] = None):
        """
        VpnServerConfiguration PolicyGroup member
        :param str attribute_type: The Vpn Policy member attribute type.
        :param str attribute_value: The value of Attribute used for this VpnServerConfigurationPolicyGroupMember.
        :param str name: Name of the VpnServerConfigurationPolicyGroupMember.
        """
        if attribute_type is not None:
            pulumi.set(__self__, "attribute_type", attribute_type)
        if attribute_value is not None:
            pulumi.set(__self__, "attribute_value", attribute_value)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter(name="attributeType")
    def attribute_type(self) -> Optional[str]:
        """
        The Vpn Policy member attribute type.
        """
        return pulumi.get(self, "attribute_type")

    @property
    @pulumi.getter(name="attributeValue")
    def attribute_value(self) -> Optional[str]:
        """
        The value of Attribute used for this VpnServerConfigurationPolicyGroupMember.
        """
        return pulumi.get(self, "attribute_value")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Name of the VpnServerConfigurationPolicyGroupMember.
        """
        return pulumi.get(self, "name")


