# coding=utf-8
# *** WARNING: this file was generated by pulumi. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'AzureFrontDoorEnabled',
    'ConfigurationType',
    'DatabaseTier',
    'DatabaseType',
    'DiskSkuName',
    'DiskStorageType',
    'EnableBackup',
    'EnableSslEnforcement',
    'FileShareStorageType',
    'FileShareType',
    'HAEnabled',
    'LoadBalancerType',
    'ManagedServiceIdentityType',
    'NamingPatternType',
    'OSImageOffer',
    'OSImagePublisher',
    'OSImageSku',
    'OSImageVersion',
    'OSType',
    'PHPVersion',
    'RedisCacheFamily',
    'RoutingPreference',
    'SAPConfigurationType',
    'SAPDatabaseScaleMethod',
    'SAPDatabaseType',
    'SAPDeploymentType',
    'SAPEnvironmentType',
    'SAPHighAvailabilityType',
    'SAPProductType',
    'SAPSoftwareInstallationType',
    'SearchType',
    'SkuTier',
    'SslPreference',
    'WordpressVersions',
    'WorkloadKind',
]


class AzureFrontDoorEnabled(str, Enum):
    """
    Whether to enable Azure front door
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class ConfigurationType(str, Enum):
    """
    The type of file share config.
    """
    SKIP = "Skip"
    CREATE_AND_MOUNT = "CreateAndMount"
    MOUNT = "Mount"


class DatabaseTier(str, Enum):
    """
    Tier of the server SKU
    """
    BURSTABLE = "Burstable"
    GENERAL_PURPOSE = "GeneralPurpose"
    MEMORY_OPTIMIZED = "MemoryOptimized"


class DatabaseType(str, Enum):
    """
    Database type
    """
    MY_SQL = "MySql"


class DiskSkuName(str, Enum):
    """
    Defines the disk sku name.
    """
    STANDARD_LRS = "Standard_LRS"
    PREMIUM_LRS = "Premium_LRS"
    STANDARD_SS_D_LRS = "StandardSSD_LRS"
    ULTRA_SS_D_LRS = "UltraSSD_LRS"
    PREMIUM_ZRS = "Premium_ZRS"
    STANDARD_SS_D_ZRS = "StandardSSD_ZRS"
    PREMIUM_V2_LRS = "PremiumV2_LRS"


class DiskStorageType(str, Enum):
    """
    Storage type
    """
    PREMIUM_LRS = "Premium_LRS"
    STANDARD_LRS = "Standard_LRS"
    STANDARD_SS_D_LRS = "StandardSSD_LRS"


class EnableBackup(str, Enum):
    """
    Whether to enable Azure backup for the workload
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class EnableSslEnforcement(str, Enum):
    """
    Whether to enable SSL enforcement on the database
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class FileShareStorageType(str, Enum):
    """
    File share backing storage type
    """
    STANDARD_LRS = "Standard_LRS"
    STANDARD_GRS = "Standard_GRS"
    STANDARD_ZRS = "Standard_ZRS"
    PREMIUM_LRS = "Premium_LRS"


class FileShareType(str, Enum):
    """
    Share type
    """
    NFS_ON_CONTROLLER = "NfsOnController"
    AZURE_FILES = "AzureFiles"


class HAEnabled(str, Enum):
    """
    Whether to enable HA for the server
    """
    ENABLED = "Enabled"
    DISABLED = "Disabled"


class LoadBalancerType(str, Enum):
    """
    Load balancer type
    """
    APPLICATION_GATEWAY = "ApplicationGateway"
    LOAD_BALANCER = "LoadBalancer"


class ManagedServiceIdentityType(str, Enum):
    """
    Type of manage identity
    """
    NONE = "None"
    USER_ASSIGNED = "UserAssigned"


class NamingPatternType(str, Enum):
    """
    The pattern type to be used for resource naming.
    """
    FULL_RESOURCE_NAME = "FullResourceName"


class OSImageOffer(str, Enum):
    """
    OS image offer
    """
    UBUNTU_SERVER = "UbuntuServer"


class OSImagePublisher(str, Enum):
    """
    OS image publisher
    """
    CANONICAL = "Canonical"


class OSImageSku(str, Enum):
    """
    OS image sku
    """
    OS_IMAGE_SKU_18_04_LTS = "18.04-LTS"
    OS_IMAGE_SKU_16_04_LTS = "16.04-LTS"


class OSImageVersion(str, Enum):
    """
    OS image version
    """
    LATEST = "latest"


class OSType(str, Enum):
    """
    The OS Type
    """
    LINUX = "Linux"
    WINDOWS = "Windows"


class PHPVersion(str, Enum):
    """
    PHP version
    """
    PHP_VERSION_7_2 = "7.2"
    PHP_VERSION_7_3 = "7.3"
    PHP_VERSION_7_4 = "7.4"


class RedisCacheFamily(str, Enum):
    """
    Cache family
    """
    C = "C"
    P = "P"


class RoutingPreference(str, Enum):
    """
    Sets the routing preference of the SAP monitor. By default only RFC1918 traffic is routed to the customer VNET.
    """
    DEFAULT = "Default"
    ROUTE_ALL = "RouteAll"


class SAPConfigurationType(str, Enum):
    """
    The configuration Type.
    """
    DEPLOYMENT = "Deployment"
    DISCOVERY = "Discovery"
    DEPLOYMENT_WITH_OS_CONFIG = "DeploymentWithOSConfig"


class SAPDatabaseScaleMethod(str, Enum):
    """
    The DB scale method.
    """
    SCALE_UP = "ScaleUp"


class SAPDatabaseType(str, Enum):
    """
    The database type. Eg: HANA, DB2, etc
    """
    HANA = "HANA"
    DB2 = "DB2"


class SAPDeploymentType(str, Enum):
    """
    The deployment type. Eg: SingleServer/ThreeTier
    """
    SINGLE_SERVER = "SingleServer"
    THREE_TIER = "ThreeTier"


class SAPEnvironmentType(str, Enum):
    """
    Defines the environment type - Production/Non Production.
    """
    NON_PROD = "NonProd"
    PROD = "Prod"


class SAPHighAvailabilityType(str, Enum):
    """
    The high availability type.
    """
    AVAILABILITY_SET = "AvailabilitySet"
    AVAILABILITY_ZONE = "AvailabilityZone"


class SAPProductType(str, Enum):
    """
    Defines the SAP Product type.
    """
    ECC = "ECC"
    S4_HANA = "S4HANA"
    OTHER = "Other"


class SAPSoftwareInstallationType(str, Enum):
    """
    The SAP software installation Type.
    """
    SERVICE_INITIATED = "ServiceInitiated"
    SAP_INSTALL_WITHOUT_OS_CONFIG = "SAPInstallWithoutOSConfig"
    EXTERNAL = "External"


class SearchType(str, Enum):
    """
    Search type
    """
    ELASTIC = "Elastic"


class SkuTier(str, Enum):
    """
    This field is required to be implemented by the Resource Provider if the service has more than one tier, but is not required on a PUT.
    """
    FREE = "Free"
    BASIC = "Basic"
    STANDARD = "Standard"
    PREMIUM = "Premium"


class SslPreference(str, Enum):
    """
    Gets or sets certificate preference if secure communication is enabled.
    """
    DISABLED = "Disabled"
    ROOT_CERTIFICATE = "RootCertificate"
    SERVER_CERTIFICATE = "ServerCertificate"


class WordpressVersions(str, Enum):
    """
    Application version
    """
    WORDPRESS_VERSIONS_5_4_3 = "5.4.3"
    WORDPRESS_VERSIONS_5_4_2 = "5.4.2"
    WORDPRESS_VERSIONS_5_4_1 = "5.4.1"
    WORDPRESS_VERSIONS_5_4 = "5.4"


class WorkloadKind(str, Enum):
    """
    Indicates which kind of php workload this resource represent e.g WordPress
    """
    WORD_PRESS = "WordPress"
